<?php

namespace objects;

use classes\db;
use classes\object_property;
use Exception;
use traits\db_object_t;

class department_selfserve_condition_rules_o extends db
{
    use db_object_t;

    public object_property $condition_id; // The condition object id
    public object_property $type; // The condition type (e.g., true/false, equals, greater than, etc.)
    public object_property $object_type; // The object type to which the condition applies (e.g., condition_id, task, condition_rule, etc.)
    public object_property $object_id; // The object id to which the condition applies
    public object_property $name; // The condition name
    public object_property $description; // The task description
    public object_property $created_at;
    public object_property $updated_at;
    public object_property $deleted_at;


    public function structure(): void
    {
        $this->setTable('department_selfserve_condition_rules');
    }

    /**
     * Add a condition rule
     * @param int $condition_id The condition object id
     * @param string $type The condition type (e.g., IS_TRUE, IS_FALSE)
     * @param string $object_type The object type to which the condition applies (e.g., condition_id, task, etc.)
     * @param int $object_id The object id to which the condition applies
     * @param string $name The condition name
     * @param string $description The condition description
     * @return department_selfserve_condition_rules_o
     * @throws Exception If the object was not created successfully
     */
    public function add(int $condition_id, string $type, string $object_type, int $object_id, string $name, string $description): department_selfserve_condition_rules_o
    {
        global /** @var db $db */
        $db;
        // Sanitize the input
        $condition_id = (int)$condition_id;
        $type = $db->escape_string($type);
        $object_type = $db->escape_string($object_type);
        $object_id = (int)$object_id;
        $name = $db->escape_string($name);
        $description = $db->escape_string($description);
        // Add the object
        $tmp_id = self::add_object([
            'condition_id' => $condition_id,
            'type' => $type,
            'object_type' => $object_type,
            'object_id' => $object_id,
            'name' => $name,
            'description' => $description,
        ]);
        $this->id = $tmp_id;
        self::getObjectProperties();
        self::objectChanged();
        return $this;
    }



    public function getObjectProperties(): void
    {
        $this->condition_id = new object_property($this->table, $this->id, 'condition_id', 'int', false);
        $this->type = new object_property($this->table, $this->id, 'type', 'string', false);
        $this->object_type = new object_property($this->table, $this->id, 'object_type', 'string', false);
        $this->object_id = new object_property($this->table, $this->id, 'object_id', 'int', false);
        $this->name = new object_property($this->table, $this->id, 'name', 'string', false);
        $this->description = new object_property($this->table, $this->id, 'description', 'string', false);
        $this->created_at = new object_property($this->table, $this->id, 'created_at', 'timestamp', false);
        $this->updated_at = new object_property($this->table, $this->id, 'updated_at', 'timestamp', false);
        $this->deleted_at = new object_property($this->table, $this->id, 'deleted_at', 'timestamp', false);
    }

    public function objectChanged(): void
    {
        //TODO: Add cache invalidation
    }

    public function asArray(): array
    {
        return [
            'id' => (int)$this->id,
            'condition_id' => (int)$this->condition_id->value(),
            'type' => (string)$this->type->value(),
            'object_type' => (string)$this->object_type->value(),
            'object_id' => (int)$this->object_id->value(),
            'name' => (string)$this->name->value(),
            'description' => (string)$this->description->value(),
            // Timestamps
            'created_at' => (string)$this->created_at->value(),
            'updated_at' => (string)$this->updated_at->value(),
        ];
    }
}